import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;


public class AdhocClientTester {

	InetAddress lastAddress=null;
	String lastStatus;
	String lastGPS;
	String name;
	
	void startThreads(String name_) {
		name=name_;
		
	    Thread clientSendThread = new Thread(new UDPClient());
        clientSendThread.start(); 
        
	    Thread clientReceiveThread = new Thread(new UDPServer());
        clientReceiveThread.start();		
	}
	
    class UDPServer implements Runnable {
        // @Override
        public void run() {
        	DatagramSocket socket;
            FriendData f=new FriendData();
            try {
            	// Initial Value in case something doesn't work
            	lastAddress=InetAddress.getByName("192.168.1.101");
            	socket = new DatagramSocket(8888);
		    } catch (Exception e) {
		        System.out.println("Server already running; client-only");
		        lastStatus="available";
		        lastGPS="none";
		        return;
		    }
			
        	while (!Thread.currentThread().isInterrupted()) {
	        	try {
    		    	byte[] buf = new byte[1024];
    	                // receive request
    	            DatagramPacket packet = new DatagramPacket(buf, buf.length);
    	            socket.receive(packet);
  		            String msg=new String(packet.getData(), 0, packet.getLength());
    	            if (packet.getAddress().getHostAddress().compareTo("192.168.1.101") != 0) {
        	            System.out.println("Received packet from: " + 
	            		           packet.getAddress().getHostAddress() +
	            		           ", port: " +
	            		           packet.getPort() +
	            		           ", msg: " + msg
	            		           );
	    	            lastAddress=packet.getAddress();
	        			if (f.isHeartbeat(msg)) {
	        				lastGPS=f.parseHeartbeat(msg);
	        				lastStatus=f.statusMsg;
	        			}
    	            }
        			
	    	    } catch (IOException e) {
	    	        e.printStackTrace();
	    	        Thread.currentThread().interrupt();
	    	    }
	    	 }
        }
    }

    class UDPClient implements Runnable {
    	
        // @Override
        public void run() {
        	
			FriendData myData=new FriendData();
			myData.name=name;
    		InetAddress dest;
			int counter=0;
        	while (!Thread.currentThread().isInterrupted()) {
        		
        		if (lastAddress != null) {
			      	try {
			      		// Convert lastAddress into a broadcast address
			      		String address=lastAddress.getHostAddress().toString();	
				    	int pos=address.lastIndexOf('.');
                		String myBcastAddress=address.substring(0, pos) + ".255";
                		dest=InetAddress.getByName(myBcastAddress);
                		myData.statusMsg=lastStatus;
						String msg=myData.makeHeartbeat(lastGPS);
						byte[] buf=new byte[msg.length()];
			    	    buf = msg.getBytes();
						DatagramPacket p=new DatagramPacket(buf, buf.length, dest, 8888);
				   		DatagramSocket s=new DatagramSocket();
			    		s.send(p);
			    	}
			    	catch (Exception e) {
			    		e.printStackTrace();
					}
	
			    	if ((counter%30) == 0) {
			    		counter=0;
				      	try {
							String msg=myData.makeMessage("Hello");
					    	byte[] buf=new byte[msg.length()];
				    	    buf = msg.getBytes();
							DatagramPacket p=new DatagramPacket(buf, buf.length, lastAddress, 8888);
					   		DatagramSocket s=new DatagramSocket();
				    		s.send(p);
				    	}
				    	catch (Exception e) {
				    		e.printStackTrace();
						}
			    	}
			    	++counter;
        		}
        		
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    Thread.currentThread().interrupt();
                }
        	}
		}
    }
    
	public static void main(String[] args) {
	
		AdhocClientTester tester=new AdhocClientTester();
		tester.startThreads(args[0]);
        
		// Sleep forever
        while (!Thread.currentThread().isInterrupted()) {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
                Thread.currentThread().interrupt();
            }
        }
	}
}
